{$R+}
{$N+}
{$M$ff00,0,$a0000}

UNIT zss3u2;                    {30.03.2000 / shu}


INTERFACE                       {UNIT zss3u2}


USES
  CTVU1;


PROCEDURE put_debug_info;
PROCEDURE wmk(sfeld:string_flenp1;tz:sftyp;tzl:longint); {Warnmeldung (Kern)}
PROCEDURE wm(sfeld:string_flenp1;tz:sftyp;tzl:longint); {Warnmeldung}
PROCEDURE anhalten;
PROCEDURE fm(sfeld:string_flenp1;tz:sftyp;tzl:longint); {Fehlermeldung}
PROCEDURE fm1(tz:sftyp;tzl:longint); {Fehlermeldung1}
PROCEDURE markiere_set_var;
PROCEDURE report_status;
FUNCTION ob_weitermachen: boolean;
PROCEDURE plus_symbole(VAR nfloc: gnr; symtyp: longint; VAR symanz: longint);
PROCEDURE sortiere_nf(VAR nfloc: gnr);
PROCEDURE schreib_querverweistabelle(VAR nam:text; VAR nfloc: gnr;
                                     str_loc: string_255);
PROCEDURE schreib_symboltabelle(VAR nam:text; VAR nfloc: gnr;
                                symanz: longint);
PROCEDURE zweiter_lauf;
PROCEDURE ganz;


IMPLEMENTATION                  {UNIT zss3u2}


USES
  DOS, CRT, ZSS3U1;


PROCEDURE put_debug_info;
  BEGIN                         {PROCEDURE put_debug_info}
    writeln;
    writeln('Als Debug-info werden geschrieben:');
    writeln('llt...');
    schreibe_alle_llt;
    writeln('Macros...');
    schreibe_macros;
    writeln('Namen...');
    schreibe_alle_nam;
  END;                          {PROCEDURE put_debug_info}

PROCEDURE wmk(sfeld:string_flenp1;tz:sftyp;tzl:longint); {Warnmeldung (Kern)}
  VAR
    i:                          longint;
  BEGIN                         {PROCEDURE wmk}
    beep;
    writeln;
    writeln('Zeile',zeile:6,': ');
    writeln;
    FOR i:=0 TO tzl-1 DO
      BEGIN
        write(tz[i]);
      END;
    writeln;
    writeln;
    writeln(sfeld);
  END;                          {PROCEDURE wmk}

PROCEDURE wm(sfeld:string_flenp1;tz:sftyp;tzl:longint); {Warnmeldung}
  BEGIN                         {PROCEDURE wm}
    writeln;
    writeln('Warnung!');
    writeln;
    wmk(sfeld, tz, tzl);
    warn_cnt:=warn_cnt+1;
  END;                          {PROCEDURE wm}

PROCEDURE anhalten;
  BEGIN                         {PROCEDURE anhalten}
    put_debug_info;
    IF tmpw_open THEN close(tmpw);
    IF tmpr_open THEN close(tmpr.bfr);
    IF lst_open THEN close(lst);
    IF obj_open THEN close(obj);
    halt;
  END;                          {PROCEDURE anhalten}

PROCEDURE fm(sfeld:string_flenp1;tz:sftyp;tzl:longint); {Fehlermeldung}
  BEGIN                         {PROCEDURE fm}
    wmk(sfeld, tz, tzl);
    anhalten;
  END;                          {PROCEDURE fm}

PROCEDURE fm1(tz:sftyp;tzl:longint); {Fehlermeldung1}
  VAR
    i:                          longint;
  BEGIN                         {PROCEDURE fm1}
    beep;
    writeln;
    writeln('Zeile',zeile:6,': ');
    writeln;
    FOR i:=0 TO pm_len-1 DO
      BEGIN
        write(pm_zeile[i]);
      END;
    writeln;
    writeln;

    FOR i:=1 TO tzl-2 DO
      BEGIN
        write(tz[i]);
      END;
    writeln;
    writeln;

    put_debug_info;
    IF tmpw_open THEN close(tmpw);
    IF tmpr_open THEN close(tmpr.bfr);
    IF lst_open THEN close(lst);
    IF obj_open THEN close(obj);
    halt;
  END;                          {PROCEDURE fm1}

PROCEDURE neue_seite(VAR lst: text; info_loc: string_255);
  VAR
    i:                          longint;

  BEGIN                         {PROCEDURE neue_seite}
    IF zeile>2 THEN             {FF fr Listing-anfang unterdrcken}
      BEGIN
        write(lst,chr(12));     {form feed}
        seite:=seite+1;
      END;
    pzc:=0;
    FOR i:=0 TO len_titel-1 DO write(lst,titel[i]);
    FOR i:=len_titel TO 116 DO write(lst,' ');
    writeln(lst,'Seite ',seite:4);
    writeln(lst);
    writeln(lst,info_loc);
    writeln(lst);
  END;                          {PROCEDURE neue_seite}

PROCEDURE markiere_set_var;
  VAR
    i:                          longint;
    nf_sel, nf_ind:             word;   {Namensfeld selector, -index}

  BEGIN                         {PROCEDURE markiere_set_var}
    {
    Die SET-Variablen liegen im 'nfl'. Dort werden vor dem zweiten
    Lauf alle Namen vom Typ 5 auf Typ 9 umbenannt.
    }
    WITH nfl DO
      BEGIN
        FOR i:=0 TO azn-1 DO
          BEGIN
            nf_sel:=(i AND (NOT max_gtnf)) SHR mgtnfb;
            nf_ind:=i AND max_gtnf;
            IF nf[nf_sel]^[nf_ind]<>NIL THEN
              BEGIN
                WITH nf[nf_sel]^[nf_ind]^ DO
                  BEGIN
                    IF nt=5 THEN        {hier Typauswahl mglich}
                      BEGIN
                        nt:=9;
                      END;      {IF nt=5}
                  END;          {WITH nf[nf_sel]^[nf_ind]^}
              END;              {IF nf[nf_sel]^[nf_ind]<>NIL}
          END;                  {FOR i}
      END;                      {WITH nfl}
  END;                          {PROCEDURE markiere_set_var}

PROCEDURE report_status;
  CONST
    xoff=                       1;
    yoff=                       7;

  BEGIN                         {PROCEDURE report_status}
    gotoxy(xoff, yoff);
    write('Zeile:          ', zeile ,'        ');
    gotoxy(xoff, yoff+2);
    write('MemAvail:       ', MemAvail ,'        ');
    gotoxy(xoff, yoff+4);
    write('MaxAvail:       ', MaxAvail ,'        ');
    writeln;
  END;                          {PROCEDURE report_status}

FUNCTION ob_weitermachen: boolean;
  VAR
    buchst:                     char;
  BEGIN                         {FUNCTION ob_weitermachen}
    write('(W)eitermachen oder (A)bbruch (w/a) ?');
    WHILE KeyPressed DO buchst:=ReadKey;
    REPEAT
      buchst:=ReadKey;
    UNTIL buchst IN ['W','w','A','a'];
    writeln;
    IF buchst IN ['W','w'] THEN ob_weitermachen:=true
    ELSE ob_weitermachen:=false;
  END;                          {FUNCTION ob_weitermachen}

PROCEDURE plus_symbole(VAR nfloc: gnr; symtyp: longint; VAR symanz: longint);
  VAR
    i:                          longint;
    nf_sel, nf_ind:             word;   {Namensfeld selector, -index}
  BEGIN                         {PROCEDURE plus_symbole}
    FOR i:=0 TO nfloc.azn-1 DO
      BEGIN
        nf_sel:=(i AND (NOT max_gtnf)) SHR mgtnfb;
        nf_ind:=i AND max_gtnf;
        WITH nfloc.nf[nf_sel]^[nf_ind]^ DO
          BEGIN
            IF nt=symtyp THEN
              BEGIN
                symanz:=symanz+1;
              END;              {IF nt=symtyp}
          END;                  {WITH nfloc.nf[nf_sel]^[nf_ind]^}
      END;                      {FOR i}
  END;                          {PROCEDURE plus_symbole}

PROCEDURE sortiere_nf(VAR nfloc: gnr);
  VAR
    i,j,k,l:                    longint;
    c1,c2:                      char;
    nf_sel, nf_ind:             word;   {Namensfeld selector, -index}
    nf_sel_i, nf_ind_i:         word;   {Namensfeld selector, -index}
    min_index:                  longint;
    kleinster:                  krznt;
    zeiger_tmp:                 znr;
  BEGIN                         {PROCEDURE sortiere_nf}
    FOR i:=0 TO nfloc.azn-2 DO
      BEGIN
        {
        Minimum erst mal mit dem ersten Label vorbesetzen:
        }
        nf_sel_i:=(i AND (NOT max_gtnf)) SHR mgtnfb;
        nf_ind_i:=i AND max_gtnf;
        min_index:=i;
        WITH nfloc.nf[nf_sel_i]^[nf_ind_i]^ DO
          BEGIN
            FOR j:=0 TO max_cl DO
              BEGIN
                kleinster[j]:=name[j];
              END;              {FOR j}
          END;                  {WITH nfloc.nf[nf_sel_i]^[nf_ind_i]^}

        {
        Nun den Rest des Feldes absuchen:
        }
        FOR k:=i+1 TO nfloc.azn-1 DO
          BEGIN
            l:=0;
            nf_sel:=(k AND (NOT max_gtnf)) SHR mgtnfb;
            nf_ind:=k AND max_gtnf;
            WITH nfloc.nf[nf_sel]^[nf_ind]^ DO
              BEGIN
                REPEAT
                  c1:=name[l];
                  c2:=kleinster[l];
                  l:=l+1;
                UNTIL ((c1<>c2) OR (l=max_cl+1));
                IF c1<c2 THEN
                  BEGIN
                    {
                    Falls der name bei Index k 'kleiner' ist
                    als unser bisheriges Minimum, werden wir
                    diesen Namen als Minimum nehmen und uns
                    den neuen Index merken:
                    }
                    FOR j:=0 TO max_cl DO
                      BEGIN
                        kleinster[j]:=name[j];
                      END;  {FOR j}
                    min_index:=k;
                  END;          {IF c1<c2}
              END;              {WITH nfloc.nf[nf_sel]^[nf_ind]^}
          END;                  {FOR k}

        {
        Wir sollten mit 'min_index' also nun den Index gefunden
        haben, der zum 'kleinsten' Namen gehrt. Wollen wir also
        zuletzt noch die Pointer entsprechend umhngen:
        }
        zeiger_tmp:=nfloc.nf[nf_sel_i]^[nf_ind_i];

        nf_sel:=(min_index AND (NOT max_gtnf)) SHR mgtnfb;
        nf_ind:=min_index AND max_gtnf;
        nfloc.nf[nf_sel_i]^[nf_ind_i]:=nfloc.nf[nf_sel]^[nf_ind];

        nfloc.nf[nf_sel]^[nf_ind]:=zeiger_tmp;
      END;                      {FOR i}
  END;                          {PROCEDURE sortiere_nf}

PROCEDURE schreib_querverweistabelle(VAR nam:text; VAR nfloc: gnr;
                                     str_loc: string_255);
  CONST
    max_pos=                    17;
  VAR
    pos:                        longint;
    zwstr, info:                string_255;
    i,j:                        longint;
    nf_sel, nf_ind:             word;   {Namensfeld selector, -index}

  PROCEDURE schreib_crr(VAR nam: text; zcrr_loc: zcrrt);
    BEGIN                       {PROCEDURE schreib_crr}
      WHILE zcrr_loc<>NIL DO
        BEGIN
          write(nam, zcrr_loc^.glob_zeile:5);
          zcrr_loc:=zcrr_loc^.zcrr;
          pos:=pos+1;
          IF zcrr_loc<>NIL THEN
            BEGIN
              IF pos=max_pos THEN
                BEGIN
                  writeln(nam);
                  write(nam, '                         ');
                  pos:=0;
                  pzc:=pzc+1;
                END             {IF pos=max_pos}
              ELSE write(nam, ',');
            END;                {IF zcrr_loc<>NIL}
        END;                    {WHILE zcrr_loc<>NIL}
    END;                        {PROCEDURE schreib_crr}

  BEGIN                         {PROCEDURE schreib_querverweistabelle}
    pos:=0;
    zwstr:='Querverweistabelle fr File ' + fname_lst + str_loc;
    str_zu_sftyp(zwstr, titel, len_titel);

    info:='Zeile   Symbol           weitere Referenzen';
    neue_seite(nam, info);

    FOR i:=0 TO nfloc.azn-1 DO
      BEGIN
        nf_sel:=(i AND (NOT max_gtnf)) SHR mgtnfb;
        nf_ind:=i AND max_gtnf;
        WITH nfloc.nf[nf_sel]^[nf_ind]^ DO
          BEGIN
            IF nt IN [2,4,5] THEN {hier Typauswahl mglich}
              BEGIN
                IF zcrr<>NIL THEN
                  BEGIN
                    IF pzc>=zpp THEN neue_seite(lst, info);
                    write(nam, zcrr^.glob_zeile:5, '   ');

                    FOR j:=0 TO max_cl DO
                      BEGIN
                        write(nam,name[j]);
                      END;  {FOR j}

                    write(nam,' ');
                    schreib_crr(nam, zcrr^.zcrr);
                    writeln(nam);
                    pos:=0;
                    pzc:=pzc+1;
                  END;          {IF zcrr<>NIL}
              END;              {IF nt IN [2,4,5]}
          END;                  {WITH nfloc.nf[nf_sel]^[nf_ind]^}
      END;                      {FOR i}
  END;                          {PROCEDURE schreib_querverweistabelle}

PROCEDURE schreib_symboltabelle(VAR nam:text; VAR nfloc: gnr;
                                symanz: longint);
  CONST
    max_pos=                    5;
  VAR
    pos:                        longint;
    zwstr, info:                string_255;
    i,j:                        longint;
    nf_sel, nf_ind:             word;   {Namensfeld selector, -index}
    erster_blank:               boolean;
  BEGIN                         {PROCEDURE schreib_symboltabelle}
    {
    Der HP-TUNIX-Assembler scheint das, was wir als Namenstyp 4 und 5
    bezeichnet haben, als Symbole zu betrachten. Der Typ 4 ist klar,
    aber beim Typ 5 (redefinable) knnte man sich schon streiten,
    weil es hier ja nicht DEN einen Wert gibt, sondern sich der
    Wert eben verndern kann. Wir geben halt den zuletzt gltigen
    aus.
    }
    pos:=0;

    zwstr:='Symboltabelle fr File ' + fname_lst;
    str_zu_sftyp(zwstr, titel, len_titel);

    info:='';
    FOR i:=1 TO max_pos DO
      BEGIN
        info:=info+'Symbol             Wert';
        IF i<max_pos THEN info:=info+'   ';
      END;                      {FOR i}
    neue_seite(nam, info);

    FOR i:=0 TO nfloc.azn-1 DO
      BEGIN
        nf_sel:=(i AND (NOT max_gtnf)) SHR mgtnfb;
        nf_ind:=i AND max_gtnf;
        WITH nfloc.nf[nf_sel]^[nf_ind]^ DO
          BEGIN
            IF nt IN [4,5] THEN {hier Typauswahl mglich}
              BEGIN
                IF pzc>=zpp THEN neue_seite(lst, info);
                erster_blank:=true;
                IF pos>0 THEN write(nam, '   ');
                FOR j:=0 TO max_cl DO
                  BEGIN
                    IF name[j]=' ' THEN
                      BEGIN
                        IF erster_blank THEN
                          BEGIN
                            write(nam, ' ');
                            erster_blank:=false;
                          END         {IF erster_blank}
                        ELSE write(nam, '.')
                      END     {IF name[j]=' '}
                    ELSE write(nam,name[j]);
                  END;  {FOR j}
                write(nam,' ');
                write_in_hex(nam, wert, 6, ' ');
                pos:=pos+1;
                IF pos=max_pos THEN
                  BEGIN
                    writeln(nam);
                    pos:=0;
                    pzc:=pzc+1;
                  END;          {IF pos=max_pos}
              END;              {IF nt IN [4,5]}
          END;                  {WITH nfloc.nf[nf_sel]^[nf_ind]^}
      END;                      {FOR i}
    IF pos>0 THEN writeln(nam);
    writeln(nam);
    IF symanz=1 THEN
      BEGIN
        writeln(nam, 'Nur ein Symbol, da gibt''s nichts zu sortieren.');
      END                       {IF symanz=1}
    ELSE
      BEGIN
        writeln(nam, symanz, ' Symbole, alphabetisch sortiert.');
      END;                      {ELSE symanz=1}
  END;                          {PROCEDURE schreib_symboltabelle}

PROCEDURE zweiter_lauf;
  CONST
    ohl=                        27;     {object header lnge}
    maxobl=                     250;    {max. object buffer lnge}
  TYPE
    oht=                        ARRAY[0..ohl] OF longint;
                                  {object header type}
    obt=                        ARRAY[0..maxobl-1] OF longint;
                                  {object buffer type}
  CONST
    oh:oht=     (128,4,32,32,32,32,32,32,32,32,32,32,32,32,32,32,
                 32,32,0,7,0,8,0,8,0,0,0,0);
                                  {object header}
  VAR
    i:                          longint;
    zeiltmp:                    longint;        {temporre Zeilen-nr}
    cb:                         iftyp;          {code buffer}
    cbl:                        longint;        {code buffer Lnge}
    ord_ch:                     byte;
    ch:                         char;
    plus_da:                    boolean;        {ist + da?}
    glnull:                     boolean;        {Digit gleich null?}
    znrs:                       krznt;          {Zeilen-nummer-string}
    ob:                         obt;            {object buffer}
    obl:                        longint;        {object buffer Lnge}
    stad:                       longint;        {Startadresse (virtuell)}
    nead:                       longint;        {neue Endadresse (virt.)}
    zdiva:                      longint;        {Zeile DIV alt}
    hw:                         longint;        {Hilfswert}
    pmb:                        iftyp;          {pmacro buffer}
    pmbl:                       longint;        {pmacro buffer Lnge}
    aazw:                       krznt;          {Zwischen-wert fr aa}
    znrszw:                     krznt;          {Zwischen-wert fr znrs}
    lenzw:                      longint;        {Zwischen-wert fr len[0]}
    zzw:                        sftyp;          {Zwischen-wert fr zlboc[0]}
    anzsl, anzsb:               longint;        {Anzahl Symbole nfl, nfb}

  PROCEDURE put_byte(wert:longint);
    VAR
      byte_wert:                byte;
    BEGIN                       {PROCEDURE put_byte}
      byte_wert:=wert AND $ff;
      write(obj,byte_wert);
    END;                        {PROCEDURE put_byte}

  PROCEDURE put_word(wert:longint);
    VAR
      byte_wert1,byte_wert2:    byte;
    BEGIN                       {PROCEDURE put_word}
      byte_wert1:=binlsr(wert,8) AND $ff;
      byte_wert2:=wert AND $ff;
      write(obj,byte_wert1,byte_wert2);
    END;                        {PROCEDURE put_word}

  PROCEDURE schreibe_obj;
    VAR
      rec_len_real:             longint;{tatschliche (Recordlnge-1)}
      rec_len_stated:           longint;{angegebene (Recordlnge-1)}
      i:                        longint;
      pstad, pstad_msw:         longint;{physikalische Startadressen}
      lpend:                    longint;{loc. phys. Ende}
      lvend:                    longint;{loc. virt. Ende}
      plvend:                   longint;{phys. loc. virt. Ende}
    BEGIN                       {PROCEDURE schreibe_obj}
      IF obl>0 THEN
        BEGIN
          {
          Wie im Kommentar dargelegt, ist 'stad' eine virtuelle Adresse,
          d.h. zur Erzeugung des Objectfiles mu eine Umrechnung in
          eine physikalische Adresse erfolgen.

          Zuerst wird aus 'stad' die physikalische Startadresse ermittelt:
          }
          pstad:=(stad AND $ffff)+binlsr(stad AND $ff0000,4);

          {
          mittels 'obl' kann die tatschlich verwendete physikalische
          Adresse des letzten in das Objectfile auszugebenden Bytes
          ermittelt werden:
          }
          lpend:=pstad+obl-1;

          {
          ebenfalls mittels 'obl' kann die virtuelle Adresse des letzten
          auszugebenden Bytes ermittelt werden:
          }
          lvend:=stad+obl-1;

          {
          aus 'lvend' wiederum lt sich bestimmen, welche physikalische
          Adresse sich fr das letzte Byte ergeben wrde, htte man
          eine direkte Umwandlung von vpc in ppc vorgenommen:
          }
          plvend:=(lvend AND $ffff)+binlsr(lvend AND $ff0000,4);

          {
          stimmen 'lpend' und 'plvend' nicht berein, geben wir eine
          Fehlermeldung aus:
          }
          IF lpend<>plvend THEN
            BEGIN
              {
              writeln;
              writeln('stad:     ', stad);
              writeln('nead:     ', nead);
              writeln('pstad:    ', pstad);
              writeln('lpend:    ', lpend);
              writeln('lvend:    ', lvend);
              writeln('plvend:   ', plvend);
              }
              wm('Objectcode berschreitet logischen Adrebereich',
                 zlboc[0],len[0]);
              IF (NOT ob_weitermachen) THEN anhalten;
            END;                {IF lpend...}

          rec_len_stated:=((obl+1) DIV 2)*2+5;
          rec_len_real:=obl+5;
          put_word(rec_len_stated);
          put_word(obl);        {Anzahl Datenbytes}
          obl:=0;
          put_word(pstad);      {LSW pstad}
          pstad_msw:=binlsr(pstad,16);
          put_word(pstad_msw);  {MSW pstad}
          FOR i:=0 TO rec_len_real-6 DO put_byte(ob[i]);  {Datenbytes}
          IF rec_len_stated>rec_len_real THEN put_byte(0);  {Padding Byte}
        END;                    {IF obl>0}
    END;                        {PROCEDURE schreibe_obj}

  PROCEDURE neues_byte(VAR wert, vadr:longint);
    BEGIN                       {PROCEDURE neues_byte}
      IF obl=0 THEN
        BEGIN
          stad:=vadr;
        END                     {IF obl=0}
      ELSE
        BEGIN
          IF ((nead+1)=vadr) THEN
            BEGIN
              IF obl=maxobl THEN
                BEGIN
                  schreibe_obj;
                  stad:=vadr;
                END;            {IF obl=maxobl}
            END                 {IF ((nead...}
          ELSE
            BEGIN
              schreibe_obj;
              stad:=vadr;
            END;                {ELSE ((nead...}
        END;                    {ELSE obl=0}
      nead:=vadr;
      ob[obl]:=wert;
      obl:=obl+1;

      cb[cbl]:=wert;
      cbl:=cbl+1;
    END;                        {PROCEDURE neues_byte}

  PROCEDURE neues_pbyte(VAR wert, vadr:longint);
    BEGIN                       {PROCEDURE neues_pbyte}
      IF obl=0 THEN
        BEGIN
          stad:=vadr;
        END                     {IF obl=0}
      ELSE
        BEGIN
          IF ((nead+1)=vadr) THEN
            BEGIN
              IF obl=maxobl THEN
                BEGIN
                  schreibe_obj;
                  stad:=vadr;
                END;            {IF obl=maxobl}
            END                 {IF ((nead...}
          ELSE
            BEGIN
              schreibe_obj;
              stad:=vadr;
            END;                {ELSE ((nead...}
        END;                    {ELSE obl=0}
      nead:=vadr;
      ob[obl]:=wert;
      obl:=obl+1;

      pmb[pmbl]:=wert;
      pmbl:=pmbl+1;
    END;                        {PROCEDURE neues_pbyte}

  PROCEDURE bestimme_daten;
    VAR
      hwl:                      longint;
      dbl,dbm,dbh:              longint;        {Datenbytes(low, middle, high}
      findex,iindex,pcn:        longint;
      gwert,gnt:                longint;
      nf_sel, nf_ind:           word;   {Namensfeld selector, -index}

    PROCEDURE bd_pseudo;
      VAR
        i,anz1,k:               longint;
        begrenzer:              char;
      BEGIN                     {PROCEDURE bd_pseudo}
        CASE gwert OF
          0:                    {ORG}
            BEGIN
              check_len(3);
              pcn:=wandle(zlboc[3],len[3]) AND $ffffff;
              pcs:=pcn;
            END;                {CASE 0}
          1:                    {EQU: nichts};
          2:                    {SET/DEFL}
            BEGIN
              check_len(1);
              check_len(3);
              insert_vmp(5,wandle(zlboc[3],len[3]),0);
            END;                {CASE 2}
          3:                    {DB}
            BEGIN
              FOR i:=3 TO ozi+2 DO
                BEGIN
                  IF len[i]>0 THEN
                    BEGIN
                      str_od_expr(zlboc[i],len[i],anz1,begrenzer);
                      IF begrenzer=' ' THEN
                        BEGIN
                          dbl:=wandle(zlboc[i],len[i]) AND $ff;
                          neues_byte(dbl, pcn);
                          pcn:=pcn+1;
                        END
                      ELSE
                        BEGIN
                          FOR k:=1 TO len[i]-2 DO
                            BEGIN
                              dbl:=ord(zlboc[i,k]);
                              neues_byte(dbl, pcn);
                              pcn:=pcn+1;
                            END;
                        END;    {ELSE begrenzer=' '}
                      pcs:=pcn;
                    END;        {IF len[i]>0}
                END;            {FOR i}
            END;                {CASE 3}
          4:                    {DS}
            BEGIN
              check_len(3);
              pcn:=pcn + wandle(zlboc[3],len[3]);
              pcs:=pcn;
            END;                {CASE 4}
          5:                    {DW}
            BEGIN
              FOR i:=3 TO ozi+2 DO
                BEGIN
                  IF len[i]>0 THEN
                    BEGIN
                      dbh:=wandle(zlboc[i],len[i]) AND $ffff;
                      dbl:=dbh AND $ff;
                      neues_byte(dbl, pcn);
                      pcn:=pcn+1;
                      dbh:=binlsr(dbh,8) AND $ff;
                      neues_byte(dbh, pcn);
                      pcn:=pcn+1;
                      pcs:=pcn;
                    END;        {IF len[i]>0}
                END;            {FOR i}
            END;                {CASE 5}
          6:                    {MACRO, nichts};
          7:                    {SKIP}
            BEGIN
              {nichts};
            END;                {CASE 7}
          8,9,10,11,12:         {INCLUDE, IF, ELSE, IFEND, ENDIF: nichts};
          13,14,15,16,17:       {MEND, .NOP, .IF, .GOTO, .SET: nichts};
          18:                   {TITLE}
            BEGIN
              titel:=zlboc[3];
              len_titel:=len[3];
            END;                {CASE 18}
          19:                   {NOLIST}
            BEGIN
              list_state:=0;
            END;                {CASE 19}
          20:                   {LIST}
            BEGIN
              list_state:=1;
              IF len[3]>0 THEN
                BEGIN
                  zpp:=wandle(zlboc[3],len[3]);
                  IF zpp>zppmax THEN zpp:=zppmax;
                END;
            END;                {CASE 20}
          21:                   {EXPAND}
            BEGIN
              list_state:=2;
              IF len[3]>0 THEN
                BEGIN
                  zpp:=wandle(zlboc[3],len[3]);
                  IF zpp>zppmax THEN zpp:=zppmax;
                END;
            END;                {CASE 21}
          22,23,24,25,26:       {COMN, NAME, PROG, DATA, END: nichts};
          27,28,29,30:          {PMACRO, PEQUATE, PMEND, PINCLUDE: nichts};
          31:                   {DP}
            BEGIN
              FOR i:=3 TO ozi+2 DO
                BEGIN
                  IF len[i]>0 THEN
                    BEGIN
                      hwl:=wandle(zlboc[i],len[i]) AND $ffffff;
                      hwl:=(hwl AND $ffff)+binlsr(hwl AND $ff0000,4);
                      dbl:=hwl AND $ff;
                      neues_byte(dbl, pcn);
                      pcn:=pcn+1;
                      dbm:=binlsr(hwl,8) AND $ff;
                      neues_byte(dbm, pcn);
                      pcn:=pcn+1;
                      dbh:=binlsr(hwl,16) AND $ff;
                      neues_byte(dbh, pcn);
                      pcn:=pcn+1;
                      pcs:=pcn;
                    END;        {IF len[i]>0}
                END;            {FOR i}
            END;                {CASE 31}

        END;                    {CASE gwert}
      END;                      {PROCEDURE bd_pseudo}

    BEGIN                       {PROCEDURE bestimme_daten}
      pcn:=pc;
      suche_name(nfb,zlboc[2],len[2],findex,iindex);
      IF findex=-1 THEN         {name nicht gefunden bei findex=-1}
        BEGIN
          fm('Befehlsname nicht gefunden',zlboc[2],len[2]);
        END
      ELSE
        BEGIN
          nf_sel:=(findex AND (NOT max_gtnf)) SHR mgtnfb;
          nf_ind:=findex AND max_gtnf;
          WITH nfb.nf[nf_sel]^[nf_ind]^ DO
            BEGIN
              gwert:=wert;
              gnt:=nt;
            END;                {WITH nf[nf_sel]^[nf_ind]^}
          CASE gnt OF
            1:    bd_pseudo;    {bestimme Daten Pseudo}
            ELSE;               {nichts}
          END;                  {CASE gnt}
        END;                    {ELSE findex=-1}
      pc:=pcn;
    END;                        {PROCEDURE bestimme_daten}

  PROCEDURE liste_zeile(VAR laa,lznrs:krznt; VAR lbl,lzl:longint;
                        VAR lz:sftyp; VAR lb:iftyp);
    VAR
      i:                        longint;
      rcnt:                     longint;        {"rest"-count}
    BEGIN                       {PROCEDURE liste_zeile}
      IF pzc>=zpp THEN neue_seite(lst, info);
      pzc:=pzc+1;
      FOR i:=0 TO 7 DO          {erst mal Adreanzeige ausgeben}
        BEGIN
          write(lst,laa[i]);
        END;                    {FOR i}
      write(lst,' ');
      FOR i:=0 TO cbpz-1 DO     {bis zu cbpz Bytes code}
        BEGIN
          IF i<lbl THEN
            BEGIN
              write(lst,h[binlsr(lb[i],4) AND $f]);
              write(lst,h[lb[i] AND $f]);
              write(lst,' ');
            END
          ELSE write(lst,'   ');
        END;                    {FOR i}
      write(lst,'  ');
      FOR i:=0 TO 4 DO write(lst,lznrs[i]);
      write(lst,' ');
      FOR i:=0 TO lzl-1 DO write(lst,lz[i]);    {Source-zeile}
      writeln(lst);             {erste Zeile fertig}
      IF list_state=2 THEN      {falls EXPAND, dann restlichen code}
        BEGIN
          rcnt:=cbpz;
          WHILE rcnt<lbl DO     {restlichen code, falls vorhanden in fol-}
            BEGIN               {gende Zeilen drucken}
              IF pzc>=zpp THEN neue_seite(lst, info);
              pzc:=pzc+1;
              write(lst,'         ');
              FOR i:=0 TO cbpz-1 DO
                BEGIN
                  IF rcnt<lbl THEN
                    BEGIN
                      write(lst,h[binlsr(lb[rcnt],4) AND $f]);
                      write(lst,h[lb[rcnt] AND $f]);
                      write(lst,' ');
                    END;
                  rcnt:=rcnt+1;
                END;            {FOR i}
              writeln(lst);
            END;                {WHILE rcnt<lbl}
        END;                    {IF list_state=2}
    END;                        {PROCEDURE liste_zeile}

  PROCEDURE notiere_zeile;
    BEGIN                       {PROCEDURE notiere_zeile}
      aazw:=aa;
      znrszw:=znrs;
      lenzw:=len[0];
      zzw:=zlboc[0];
      {
      Als weitere Aktion wird der Pmacro-Aufruf fr eine ggf.
      spter auszugebende Fehlermeldung global abgespeichert.
      }
      pm_len:=len[0];
      pm_zeile:=zlboc[0];
    END;                        {PROCEDURE notiere_zeile}

  PROCEDURE bestimme_pm_daten;
    VAR
      dbl,dbh:                  longint;        {Datenbytes(low, high}
      pcn,i:                    longint;
      ord_ch:                   byte;
      ch:                       char;

    BEGIN                       {PROCEDURE bestimme_pm_daten}
      pcn:=pc;
      REPEAT
        FOR i:=0 TO 7 DO        {Adreanzeige berlesen}
          BEGIN
            myread(tmpr,ord_ch);
            aa[i]:=Chr(ord_ch);
          END;                  {FOR i}

        myread(tmpr,ord_ch);
        zb:=Chr(ord_ch);
        myread(tmpr,ord_ch);
        zl:=Chr(ord_ch);

        FOR i:=0 TO 4 DO        {Zeilen-nr. berlesen}
          BEGIN
            myread(tmpr,ord_ch);
            ch:=Chr(ord_ch);
          END;                  {FOR i}

        zeile_abgrasen(tmpr,ozi,len,zlboc);
        cbl:=0;
        CASE zlboc[2,0] OF
          'b','B':
            BEGIN
              FOR i:=3 TO ozi+2 DO
                BEGIN
                  IF len[i]>0 THEN
                    BEGIN
                      dbl:=wandle(zlboc[i],len[i]) AND $ff;
                      neues_pbyte(dbl, pcn);
                      pcn:=pcn+1;
                    END;        {IF len[i]>0}
                END;            {FOR i}
            END;                {CASE 'b','B'}

          'w','W':
            BEGIN
              FOR i:=3 TO ozi+2 DO
                BEGIN
                  IF len[i]>0 THEN
                    BEGIN
                      dbh:=wandle(zlboc[i],len[i]) AND $ffff;
                      dbl:=dbh AND $ff;
                      neues_pbyte(dbl, pcn);
                      pcn:=pcn+1;
                      dbh:=binlsr(dbh,8) AND $ff;
                      neues_pbyte(dbh, pcn);
                      pcn:=pcn+1;
                    END;        {IF len[i]>0}
                END;            {FOR i}
            END;                {CASE 'w','W'}

          'p':
            BEGIN
              IF (wandle(zlboc[3],len[3]) <> 0) THEN
                BEGIN
                  fm1(zlboc[4],len[4]);
                END;            {IF (wandle... }

            END;                {CASE 'p'}

        END;                    {CASE zlboc[2,0]}
      UNTIL zl='e';
      pc:=pcn;
      pcs:=pc;
    END;                        {PROCEDURE bestimme_pm_daten}

  BEGIN                         {PROCEDURE zweiter_lauf}
    page;
    writeln;
    writeln;
    writeln('********        Zweiter Lauf        *******');
    writeln;
    writeln('File:           ',fname_tmp);
    writeln;

    seite:=1;                   {vorbesetzt: Seiten-nummer 1}
    len_titel:=0;               {vorbesetzt: Titel-lnge null}
    zpp:=zppdef;                {vorbesetzt: maximal zppdef Zeilen pro Seite}
    pzc:=maxlongint;            {page Zeilen count so setzen, da die erste}
                                {Seite eine berschrift bekommt, dabei wird}
                                {FF fr zeile<=2 unterdrckt.}
    info:='Adresse       Daten       Zeile         Text';
    zeile:=0;                   {zeile rcksetzen}
    zdiva:=0;                   {zeile DIV alt rcksetzen}
    pc:=0;                      {program counter}
    pcs:=0;                     {program counter 'step'}
    mel:=0;                     {macro expand level}
    fil:=0;                     {file include level}
    list_state:=1;

    report_status;

    assign(tmpr.bfr,fname_tmp);
    myreset(tmpr);
    tmpr_open:=true;

    assign(lst,fname_lst);
    rewrite(lst);
    lst_open:=true;

    assign(obj,fname_obj);
    rewrite(obj);
    obj_open:=true;

    FOR i:=0 TO ohl DO          {object header schreiben}
      BEGIN
        hw:=oh[i];
        put_byte(hw);
      END;
    obl:=0;                     {object buffer Lnge rcksetzen}
    pmbl:=0;                    {pmacro buffer Lnge rcksetzen}
    WHILE NOT myeof(tmpr) DO
      BEGIN
        FOR i:=0 TO 7 DO        {Adreanzeige lesen}
          BEGIN
            myread(tmpr,ord_ch);
            aa[i]:=Chr(ord_ch);
          END;                  {FOR i}

        myread(tmpr,ord_ch);
        zb:=Chr(ord_ch);
        myread(tmpr,ord_ch);
        zl:=Chr(ord_ch);

        plus_da:=false;
        glnull:=true;           {gleich null vorbesetzen}
        FOR i:=0 TO 4 DO        {fhrende Nullen unterdrcken}
          BEGIN
            myread(tmpr,ord_ch);
            ch:=Chr(ord_ch);
            IF ch='+' THEN plus_da:=true;
            IF glnull THEN
              BEGIN
                IF ch='0' THEN znrs[i]:=' '
                ELSE
                  BEGIN
                    glnull:=false;
                    znrs[i]:=ch;
                  END;          {ELSE ch='0'}
              END               {IF NOT grnull}
            ELSE  znrs[i]:=ch;
          END;                  {FOR i}
        zeile_abgrasen(tmpr,ozi,len,zlboc);

        IF NOT plus_da THEN
          BEGIN
            zeiltmp:=0;
            FOR i:=0 TO 4 DO
              BEGIN
                CASE znrs[i] OF
                  ' ':        {nichts};
                  '0'..'9':   zeiltmp:=zeiltmp*10+ord(znrs[i])-48;
                END;            {CASE znrs[i]}
              END;              {FOR i}
            zeile:=zeiltmp;
          END;

        IF zdiva<>zeile DIV zdiva_div THEN
          BEGIN
            zdiva:=zeile DIV zdiva_div;
            report_status;
          END;

        cbl:=0;
        IF zb='j' THEN          {bei zb='j' wird Zeile bearbeitet, d.h.}
          BEGIN                 {Daten bestimmt}
            IF len[2]>0 THEN bestimme_daten;
          END;                  {IF zb='j'}
        CASE zl OF
          'j':                  {Zeile sofort listen}
            BEGIN
              liste_zeile(aa,znrs,cbl,len[0],zlboc[0],cb);
            END;
          'p':                  {Pmacro bearbeiten und Aufruf listen}
            BEGIN
              notiere_zeile;
              bestimme_pm_daten;
              liste_zeile(aazw,znrszw,pmbl,lenzw,zzw,pmb);
              pmbl:=0;          {pm buffer Lnge wieder rcksetzen}
            END;
          'q':                  {Pmacro nur bearbeiten, nicht listen}
            BEGIN
              bestimme_pm_daten;
              pmbl:=0;          {pm buffer Lnge wieder rcksetzen}
            END;
          'N':                  {SKIP, TITLE: weder listen noch FF ausfhren}
            BEGIN
              {nichts}
            END;
          'L':                  {SKIP, TITLE: nur listen, nicht FF ausfhren}
            BEGIN
              liste_zeile(aa,znrs,cbl,len[0],zlboc[0],cb);
            END;
          'F':                  {SKIP, TITLE: nicht listen, nur FF ausfhren}
            BEGIN               {Fr Listing-anfang keine neue Seite! Der}
              IF zeile>2 THEN neue_seite(lst, info);    {titel wird aber aktualisiert}
            END;                                {(siehe bei TITLE)}
          'n':                  {nichts};
        END;                    {CASE zl}

      END;                      {WHILE NOT myeof(tmpr)}
    schreibe_obj;
    page;
    writeln;
    writeln;
    writeln('********        Zweiter Lauf        *******');
    writeln;
    writeln('File:           ',fname_tmp);
    writeln;
    report_status;
    writeln;
    writeln('Assemblierung von ',fname_usp);
    write('ohne offensichtliche Fehler ');
    CASE warn_cnt OF
      0:        {nichts};
      1:        write('(aber mit einer Warnung) ');
      ELSE      write('(aber mit ' ,warn_cnt, ' Warnungen) ');
    END;                        {CASE warn_cnt}
    writeln('beendet');

    {
    Am Ende werden Querverweis- und Symboltabelle ausgegeben, vorher
    mssen wir aber noch ein bichen sortieren. Weil wir, wie
    immer, Speicherplatz sparen msssen, tun wir das 'in situ',
    d.h. wir pfuschen direkt in den Namensfeldern (nfl, bzw. nfb)
    herum. Damit sind nfl bzw. nfb natrlich anschlieend fr nicht
    viel mehr als zur Ausgabe von Querverweis- und Symboltabelle zu
    gebrauchen.
    }

    anzsl:=0;
    plus_symbole(nfl, 4, anzsl);
    plus_symbole(nfl, 5, anzsl);

    anzsb:=0;
    plus_symbole(nfb, 2, anzsb);

    sortiere_nf(nfl);
    sortiere_nf(nfb);

    writeln;

    IF (will_quervw AND ((anzsl<>0) OR (anzsb<>0))) THEN
      BEGIN
        write('Querverweistabelle wird ausgegeben...');
        IF anzsl<>0 THEN
          BEGIN
            schreib_querverweistabelle(lst, nfl, ' (Labels, Konstanten und Variablen)');
          END;                  {anzsl<>0}
        IF anzsb<>0 THEN
          BEGIN
            schreib_querverweistabelle(lst, nfb, ' (Macros)');
          END;                  {anzsb<>0}
        writeln;
      END;                      {(will_quervw..}

    IF (will_symtab AND (anzsl<>0)) THEN
      BEGIN
        write('Symboltabelle wird ausgegeben...');
        schreib_symboltabelle(lst, nfl, anzsl);
        writeln;
      END;                      {(will_symtab...}

    close(obj);
    obj_open:=false;
    close(lst);
    lst_open:=false;
    close(tmpr.bfr);
    tmpr_open:=false;
    beep;
    mein_delay(400);
    beep;
  END;                          {PROCEDURE zweiter_lauf}

PROCEDURE ganz;
  VAR
    file_name_gueltig:          boolean;

  BEGIN                         {PROCEDURE ganz}
    initialisierung;
    welches_file(file_name_gueltig);
    IF file_name_gueltig THEN
      BEGIN
        erster_lauf;
        markiere_set_var;
        zweiter_lauf;
        {
        put_debug_info;
        }
      END;                      {IF file_name_gueltig}
  END;                          {PROCEDURE ganz}

END.                            {UNIT zss3u2}

